package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.LoginLog;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class LoginLogSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<LoginLog> selectCond;
	private JSONObject customsearchval;
	public LoginLogSearchFilter(){
		this.page =new Page<LoginLog>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<LoginLog>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_loginaccountid_eq;

	public void setN_loginaccountid_eq(String n_loginaccountid_eq) {
        this.n_loginaccountid_eq = n_loginaccountid_eq;
        if(!StringUtils.isEmpty(this.n_loginaccountid_eq)){
            this.selectCond.eq("loginaccountid", n_loginaccountid_eq);
        }
    }
	private String n_loginaccountname_eq;

	public void setN_loginaccountname_eq(String n_loginaccountname_eq) {
        this.n_loginaccountname_eq = n_loginaccountname_eq;
        if(!StringUtils.isEmpty(this.n_loginaccountname_eq)){
            this.selectCond.eq("loginaccountname", n_loginaccountname_eq);
        }
    }
	private String n_loginaccountname_like;

	public void setN_loginaccountname_like(String n_loginaccountname_like) {
        this.n_loginaccountname_like = n_loginaccountname_like;
        if(!StringUtils.isEmpty(this.n_loginaccountname_like)){
            this.selectCond.like("loginaccountname", n_loginaccountname_like);
        }
    }
	private String n_loginlogname_like;

	public void setN_loginlogname_like(String n_loginlogname_like) {
        this.n_loginlogname_like = n_loginlogname_like;
        if(!StringUtils.isEmpty(this.n_loginlogname_like)){
            this.selectCond.like("loginlogname", n_loginlogname_like);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_LOGINLOG_LOGINACCOUNT_LOGINACCOUNTID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_loginaccountid_eq("NA");
			}
			else{
				this.setN_loginaccountid_eq(strParentkey);
			}
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("loginlogname",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}